// Script layout for BVQX 2.2 generated by ScriptFromUI Plugin
// NOTE: Instead of "dlg.findChild()" we use "bvqx.FindChild()" since "findChild" is currently not working with script extensions

var bvqx = BrainVoyager; // use short symbol to access BrainVoyager API (updated from 'BrainVoyagerQX' to 'BrainVoyager' on 24-09-18)

var scriptObj = new Object;
scriptObj.scriptNameForUser = "VMPsPropertyEditor"; // NOT relevant for Plugin GUI script - specify name by which script will be shown to user (e.g. in menu)
scriptObj.dialogFileName    = "VMPsPropertyEditor.ui"; // specify name of file that will be used by BVQX to create your UI
scriptObj.dialogAccessName  = "PluginDialog"; // specify the name you want to use for accessing your UI

// Initializing global variables for GUI elements
// push buttons
var pushB_Start;
// radio buttons
var rb_MapNrs, rb_NoMaps, rb_AllMaps;
// check boxes
var chBox_SetMin, chBox_SetMax, chBox_ClusterSize, chBox_UseClusterSize, chBox_ShowPosNegBoth, chBox_Transparancy, chBox_OverlayMaps;
// spin boxes
var dspBox_Min, dspBox_Max, dspBox_Trans, spBox_ClusterSize;
// combo boxes
var comboBox_UseCluster, comboBox_PNB, comboBox_Overlay;
// line edit
var le_MapNrs;
// dialog itself
var dlg;


scriptObj.initDlg = function()
{
   dlg = this.PluginDialog; // less to write
   // find push buttons
   pushB_Start = bvqx.FindChild("pushB_Start");
      // find radio buttons
   rb_MapNrs = bvqx.FindChild("rb_MapNrs");
   rb_AllMaps = bvqx.FindChild("rb_AllMaps");
   // find check boxes
   chBox_SetMin = bvqx.FindChild("chBox_SetMin");
   chBox_SetMinP = bvqx.FindChild("chBox_SetMinP");
   chBox_SetMax = bvqx.FindChild("chBox_SetMax");
   chBox_ClusterSize = bvqx.FindChild("chBox_ClusterSize");
   chBox_UseClusterSize = bvqx.FindChild("chBox_UseClusterSize");
   chBox_ShowPosNegBoth = bvqx.FindChild("chBox_ShowPosNegBoth");
   chBox_Transparancy = bvqx.FindChild("chBox_Transparancy");
   chBox_OverlayMaps = bvqx.FindChild("chBox_OverlayMaps");
   // find spin boxes
   dspBox_Min = bvqx.FindChild("dspBox_Min");
   dspBox_MinP = bvqx.FindChild("dspBox_MinP");
   dspBox_Max = bvqx.FindChild("dspBox_Max");
   dspBox_Trans = bvqx.FindChild("dspBox_Trans");
   spBox_ClusterSize = bvqx.FindChild("spBox_ClusterSize");
   //find group boxes
   grBox_OverlayMaps = bvqx.FindChild("grBox_OverlayMaps");
   // find combo boxes
   comboBox_UseCluster = bvqx.FindChild("comboBox_UseCluster");
   comboBox_PNB = bvqx.FindChild("comboBox_PNB");
   comboBox_Overlay = bvqx.FindChild("comboBox_Overlay");
   // find line edit
   le_MapNrs = bvqx.FindChild("le_MapNrs");
   // connec UI elements to script functions - you need to know the names of your elements (check your definition)
   pushB_Start.clicked.connect(this, this.clicked_pushB_Start);
}


scriptObj.clicked_pushB_Start = function()
{
   bvqx.PrintToLog("VMPsPropertyEditor>  Dialog's Start button clicked");
   
   bvqx.SetPluginIntParameter("DoSetMin", chBox_SetMin.checked);
   bvqx.SetPluginIntParameter("DoSetMinP", chBox_SetMinP.checked);
   bvqx.SetPluginIntParameter("DoSetMax", chBox_SetMax.checked);
   bvqx.SetPluginIntParameter("DoClusterSize", chBox_ClusterSize.checked);
   bvqx.SetPluginIntParameter("DoUseClusterSize", chBox_UseClusterSize.checked);
   bvqx.SetPluginIntParameter("DoShowPosNegBoth", chBox_ShowPosNegBoth.checked);
   bvqx.SetPluginIntParameter("DoTransparancy", chBox_Transparancy.checked);
   bvqx.SetPluginIntParameter("DoOverlayMaps", grBox_OverlayMaps.checked);
   
   bvqx.SetPluginFloatParameter("Min", dspBox_Min.value);
   bvqx.SetPluginFloatParameter("MinP", dspBox_MinP.value);
   bvqx.SetPluginFloatParameter("Max", dspBox_Max.value);
   bvqx.SetPluginFloatParameter("Trans", dspBox_Trans.value);
   bvqx.SetPluginIntParameter("ClusterSize", spBox_ClusterSize.value);
   bvqx.SetPluginIntParameter("UseCluster", comboBox_UseCluster.currentIndex);
   bvqx.SetPluginIntParameter("PNB", comboBox_PNB.currentIndex);
   if (rb_AllMaps.checked == 1){
      bvqx.SetPluginStringParameter("Overlay", "All");
   } else if (rb_MapNrs.checked == 1){
      bvqx.SetPluginStringParameter("Overlay", le_MapNrs.text)
   }
   dlg.close();
   
   bvqx.ExecutePlugin();

}


returnScriptObj = function()
{
   return scriptObj; // it is important to return script object containing properties and functions to be called from BrainVoyager QX
}
returnScriptObj();
